#modules/manual_moctest.py

import tkinter as tk
from tkinter import messagebox
from openpyxl import load_workbook
from pathlib import Path
import sys
import json
import random
import customtkinter
from customtkinter import (CTkToplevel, CTkFrame, CTkLabel, CTkButton, 
                           CTkEntry, CTkOptionMenu, CTkCheckBox, CTkScrollableFrame)




class ManualMocktestPopup(CTkToplevel): #Mac
    def __init__(self, parent, main_frame=None, excel_file=None, count=None, default_font=None,
                 실모rows=None, 실모rows_with_hard_level=None, 문제rows_with_options=None,
                 내용일치_option=None, 함축의미_option=None, 빈칸추론_option=None, 추론_option=None,
                 추론불가_option=None, 순서_option=None, 삽입_option=None, 요지_option=None, 요약_option=None, 영작1_option=None, 영작2_option=None, 동형문제_option=None,
                 process_excel_callback=None):
        super().__init__(parent)
        
        self.process_excel_callback = process_excel_callback

        self.title("실전모의고사 수동출제")
        # Changed geometry from 600x500 to 650x500
        self.geometry("690x500")
        self.minsize(690, 500)        
    

        # Define column widths as class constants
        self.COL_WIDTHS = {
            "번호": 40,
            "지문선택": 200,
            "문제유형": 130,
            "난이도": 100,
            "출제방식": 60,
            "옵션": 50,
            "삭제": 50
        }


        self.default_font = default_font

        self.main_frame_ref = main_frame
        self.excel_file = excel_file
        self.count = count  # initial number of rows
        self.실모rows = 실모rows
        self.실모rows_with_hard_level = 실모rows_with_hard_level
        
        #self.문제rows_with_options = 문제rows_with_options #아직 수동실모에서 옵션 기능 세팅이 다 안끝남. 가령 내용일치한, 어휘3단계 등.
        self.문제rows_with_options = ["내용일치", "함축의미", "빈칸추론", "추론", "추론불가", "순서", "삽입", "요지", "요약", "영작1", "영작2", "동형문제"] #아직 수동실모에서 옵션 기능 세팅이 다 안끝남. 가령 내용일치한, 어휘3단계 등. 그래서 이걸로 일단 대체.


        # Assign option functions
        self.내용일치_option = 내용일치_option
        self.함축의미_option = 함축의미_option
        self.빈칸추론_option = 빈칸추론_option
        self.추론_option = 추론_option
        self.추론불가_option = 추론불가_option
        self.순서_option = 순서_option
        self.삽입_option = 삽입_option
        self.요지_option = 요지_option
        self.요약_option = 요약_option
        self.영작1_option = 영작1_option
        self.영작2_option = 영작2_option

        self.동형문제_option = 동형문제_option

        # Load items from "대기열" sheet column A
        self.waiting_list_items = self.load_waiting_list_items()

        # Lists to store references to the variables and widgets per row
        self.selected_waiting_items = []
        self.selected_problem_types = []
        self.hardness_menus = []
        self.option_buttons = []
        self.row_widgets = []

        main_frame = CTkFrame(self, fg_color="transparent")
        main_frame.pack(fill="both", expand=True, padx=10, pady=10)
        main_frame.grid_rowconfigure(1, weight=1)
        main_frame.grid_columnconfigure(0, weight=1)

        # Create header labels
        header_frame = CTkFrame(main_frame, fg_color="transparent")
        header_frame.grid(row=0, column=0, sticky="ew", padx=(5, 15))
        
        # Configure columns with exact widths
        header_frame.grid_columnconfigure(0, weight=0, minsize=self.COL_WIDTHS["번호"])
        header_frame.grid_columnconfigure(1, weight=0, minsize=self.COL_WIDTHS["지문선택"]-10)
        header_frame.grid_columnconfigure(2, weight=0, minsize=self.COL_WIDTHS["문제유형"]-10)
        header_frame.grid_columnconfigure(3, weight=0, minsize=self.COL_WIDTHS["난이도"]-10)
        header_frame.grid_columnconfigure(4, weight=0, minsize=self.COL_WIDTHS["출제방식"]-10)
        header_frame.grid_columnconfigure(5, weight=0, minsize=self.COL_WIDTHS["옵션"]-10)
        header_frame.grid_columnconfigure(6, weight=0, minsize=self.COL_WIDTHS["삭제"]-10)


        # Header Labels (complete section)
        CTkLabel(header_frame, width=self.COL_WIDTHS["번호"], height=18, 
                text="번호", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=0, sticky='nsew', padx=(0, 5), pady=(5, 0))

        CTkLabel(header_frame, width=self.COL_WIDTHS["지문선택"], height=18,
                text="대기열에서 지문 선택", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=1, sticky='nsew', padx=(0), pady=(5, 0))

        CTkLabel(header_frame, width=self.COL_WIDTHS["문제유형"], height=18,
                text="문제유형 선택", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=2, sticky='nsew', padx=(0), pady=(5, 0))

        CTkLabel(header_frame, width=self.COL_WIDTHS["난이도"], height=18,
                text="난이도 선택", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=3, sticky='nsew', padx=(0), pady=(5, 0))

        CTkLabel(header_frame, width=self.COL_WIDTHS["출제방식"], height=18,
                text="출제방식", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=4, sticky='nsew', padx=(0), pady=(5, 0))

        CTkLabel(header_frame, width=self.COL_WIDTHS["옵션"], height=18,
                text="옵션", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=5, sticky='nsew', padx=(0), pady=(5, 0))

        CTkLabel(header_frame, width=self.COL_WIDTHS["삭제"], height=18,
                text="삭제", font=(self.default_font, 11),
                fg_color="transparent", text_color="black"
                ).grid(row=0, column=6, sticky='e', padx=(0), pady=(5, 0))

        # Create the scrollable frame
        # Create the scrollable frame with matching column configurations
        self.scrollable_frame = CTkScrollableFrame(main_frame, fg_color="transparent")
        self.scrollable_frame.grid(row=1, column=0, sticky='nsew', padx=0, pady=0)
        
        self.scrollable_frame.grid_columnconfigure(0, weight=0, minsize=self.COL_WIDTHS["번호"])
        self.scrollable_frame.grid_columnconfigure(1, weight=0, minsize=self.COL_WIDTHS["지문선택"])
        self.scrollable_frame.grid_columnconfigure(2, weight=0, minsize=self.COL_WIDTHS["문제유형"])
        self.scrollable_frame.grid_columnconfigure(3, weight=0, minsize=self.COL_WIDTHS["난이도"])
        self.scrollable_frame.grid_columnconfigure(4, weight=0, minsize=self.COL_WIDTHS["출제방식"])
        self.scrollable_frame.grid_columnconfigure(5, weight=0, minsize=self.COL_WIDTHS["옵션"])
        self.scrollable_frame.grid_columnconfigure(6, weight=0, minsize=self.COL_WIDTHS["삭제"])

        # Define plus_button first, but don't place it yet
        self.plus_button = CTkButton(
            self.scrollable_frame,
            text="+",
            width=40,
            height=25,
            fg_color="#FEF9E0",
            hover_color="#DDA15C",
            text_color='black',
            font=(self.default_font, 13, 'bold'),
            command=self.add_row
        )
                
        # Now add the initial rows
        for i in range(self.count):
            self.add_row()

        # After adding initial rows, place the plus_button
        self.plus_button.grid(row=self.count+1, column=0, columnspan=7, pady=10)


        # Bottom frame
        button_frame = CTkFrame(self, fg_color="#2B3D2D")
        button_frame.pack(side='bottom', fill='x', pady=(5, 0))

        # Create two lines
        top_line_frame = CTkFrame(button_frame, fg_color="transparent")
        top_line_frame.pack(side='top', fill='x', pady=(5, 5))

        bottom_line_frame = CTkFrame(button_frame, fg_color="transparent")
        bottom_line_frame.pack(side='top', fill='x', pady=(0, 5))

        # === PRESET SAVE/LOAD UI on the top line ===
        preset_controls_frame = CTkFrame(top_line_frame, fg_color="transparent")
        preset_controls_frame.pack(side=tk.LEFT, fill='x', expand=True, padx=(10, 10), pady=0)

        CTkLabel(preset_controls_frame, text="문제유형 불러오기:", font=(self.default_font, 12), text_color="white").pack(side=tk.LEFT, padx=(0, 5))

        self.preset_combobox = customtkinter.CTkComboBox(
            preset_controls_frame,
            font=(self.default_font, 12),
            command=self.on_preset_selected,
            state='readonly',
            width=180
        )
        self.preset_combobox.pack(side=tk.LEFT, padx=5)
        self.preset_combobox.set("불러올 프리셋 선택")

        delete_preset_button = CTkButton(
            preset_controls_frame,
            text="삭제",
            command=self.delete_preset,
            width=40,
            height=25,
            fg_color="white",
            hover_color="#DDA15C",
            text_color='black',
            font=(self.default_font, 12, 'bold')
        )
        delete_preset_button.pack(side=tk.LEFT, padx=5)



        save_preset_button = CTkButton(
            preset_controls_frame,
            text="저장",
            command=self.save_preset,
            width=40,
            height=25,
            fg_color="white",
            hover_color="#DDA15C",
            text_color='black',
            font=(self.default_font, 12, 'bold')
        )
        save_preset_button.pack(side=tk.RIGHT, padx=5)

        self.preset_name_entry = CTkEntry(
            preset_controls_frame,
            width=180,
            placeholder_text="저장할 프리셋 이름"
        )
        self.preset_name_entry.pack(side=tk.RIGHT, padx=5)


        # === Additional Buttons on the bottom line ===
        random_select_button = CTkButton(
            bottom_line_frame, 
            text="유형 랜덤 선택", 
            width=90, height=25, 
            fg_color="#FEF9E0", 
            hover_color="#DDA15C", 
            text_color='black', 
            font=(self.default_font, 13, 'bold'), 
            command=self.randomize_problem_types
        )
        random_select_button.pack(side='left', padx=10, pady=5)

        all_hard_button = CTkButton(
            bottom_line_frame, 
            text="전부 Hard 선택", 
            width=90, height=25, 
            fg_color="#FEF9E0", 
            hover_color="#DDA15C", 
            text_color='black', 
            font=(self.default_font, 13, 'bold'), 
            command=self.set_all_hard
        )
        all_hard_button.pack(side='left', padx=10, pady=5)


        start_button = CTkButton(
            bottom_line_frame, 
            text="출제시작", 
            width=70, 
            height=25, 
            fg_color="#FEF9E0", 
            hover_color="#DDA15C", 
            text_color='black', 
            font=(self.default_font, 13, 'bold'), 
            command=self.start
        )
        start_button.pack(side='right', padx=10, pady=5)

        cancel_button = CTkButton(
            bottom_line_frame,
            text="취소", 
            width=70, 
            height=25, 
            fg_color="#FEF9E0", 
            hover_color="#DDA15C", 
            text_color='black', 
            font=(self.default_font, 13, 'bold'), 
            command=self.cancel
        )
        cancel_button.pack(side='right', padx=10, pady=5)


        # Initialize presets
        self.app_data_dir = Path.home() / ".my_application_data"
        self.app_data_dir.mkdir(exist_ok=True)
        self.presets_file = self.app_data_dir / "manual_mocktest_presets.json"
        self.load_presets()

        self.bind("<Escape>", self.cancel)



    def add_row(self):
        row_idx = len(self.row_widgets) + 1  # rows start at 1

        # Determine default values based on the previous row if exists
        if self.row_widgets:
            last_row_data = self.row_widgets[-1]
            default_problem_type = last_row_data['problem_var'].get()
            default_hardness = last_row_data['hardness_var'].get()
        else:
            default_problem_type = self.실모rows[0] if self.실모rows else ""
            default_hardness = "Normal"




        # Column 0: Row number
        index_label = CTkLabel(self.scrollable_frame,
                            text=str(row_idx),
                            font=(self.default_font, 10, "bold"),
                            width=self.COL_WIDTHS["번호"],
                            height=19,
                            corner_radius=5,
                            text_color="black",
                            fg_color="#B6C2B7")
        index_label.grid(row=row_idx, column=0, sticky='ew', padx=(0, 5), pady=3)

        # Column 1: 대기열에서 지문 선택
        waiting_var = tk.StringVar()
        if row_idx-1 < len(self.waiting_list_items):
            waiting_var.set(self.waiting_list_items[row_idx-1])
        else:
            waiting_var.set("지문을 선택하세요")

        all_values_for_waiting = self.waiting_list_items if self.waiting_list_items else [""]
        waiting_menu = CTkOptionMenu(
            self.scrollable_frame,
            variable=waiting_var,
            values=all_values_for_waiting,
            width=self.COL_WIDTHS["지문선택"]-10,
            height=30,
            bg_color='transparent',
            button_color='#FEF9E0',
            fg_color='white',
            text_color='black',
            hover=True,
            button_hover_color='#CA7900',
            dropdown_hover_color='#CA7900',
            font=(self.default_font, 11),
            dynamic_resizing=False
        )
        waiting_menu.grid(row=row_idx, column=1, sticky='ew', padx=(5, 5), pady=3)

        # Column 2: 문제유형 선택
        problem_var = tk.StringVar(value=default_problem_type)
        problem_menu = CTkOptionMenu(
            self.scrollable_frame,
            variable=problem_var,
            values=self.실모rows,
            width=self.COL_WIDTHS["문제유형"]-10,
            height=30,
            bg_color='transparent',
            button_color='#FEF9E0',
            fg_color='white',
            text_color='black',
            hover=True,
            button_hover_color='#CA7900',
            dropdown_hover_color='#CA7900',
            font=(self.default_font, 11),
            dynamic_resizing=False,
        )
        problem_menu.grid(row=row_idx, column=2, sticky='ew', padx=(5, 5), pady=3)

        # Column 3: 난이도 선택
        hardness_var = tk.StringVar(value=default_hardness)
        hardness_values = ["Normal"]
        if problem_var.get() in self.실모rows_with_hard_level:
            hardness_values = ["Normal", "Hard"]
            if default_hardness not in hardness_values:
                hardness_var.set("Normal")
        else:
            hardness_var.set("Normal")

        hardness_menu = CTkOptionMenu(
            self.scrollable_frame,
            variable=hardness_var,
            values=hardness_values,
            width=self.COL_WIDTHS["난이도"]-10,
            height=30,
            bg_color='transparent',
            button_color='#FEF9E0',
            fg_color='white',
            text_color='black',
            hover=True,
            button_hover_color='#CA7900',
            dropdown_hover_color='#CA7900',
            font=(self.default_font, 11),
            dynamic_resizing=False
        )
        hardness_menu.grid(row=row_idx, column=3, sticky='ew', padx=(5, 5), pady=0)

        # Column 4: 출제방식
        current_status_label = CTkLabel(self.scrollable_frame,
                                    width=self.COL_WIDTHS["출제방식"]-10,
                                    font=(self.default_font, 11),
                                    fg_color="transparent")
        current_status_label.grid(row=row_idx, column=4, sticky='ew', padx=(5, 5), pady=3)

        # Column 5: 옵션 버튼
        option_button = CTkButton(
            self.scrollable_frame,
            text="옵션",
            width=self.COL_WIDTHS["옵션"]-10,
            height=15,
            font=(self.default_font, 11),
            fg_color="white",
            hover_color="#DDA15E",
            text_color="black"
        )
        option_button.grid(row=row_idx, column=5, sticky='ew', padx=(5, 5), pady=0)

        # Column 6: 삭제 버튼
        delete_button = CTkButton(
            self.scrollable_frame,
            text="-",
            width=self.COL_WIDTHS["삭제"]-10,
            height=25,
            fg_color="#FEF9E0",
            hover_color="#DDA15C",
            text_color='black',
            font=(self.default_font, 13, 'bold'),
            command=lambda: self.delete_row(row_data)
        )
        delete_button.grid(row=row_idx, column=6, sticky='e', padx=(5, 0), pady=3)

        # Rest of the method remains the same
        row_data = {
            'index_label': index_label,
            'waiting_menu': waiting_menu,
            'problem_menu': problem_menu,
            'hardness_menu': hardness_menu,
            'option_button': option_button,
            'delete_button': delete_button,
            'waiting_var': waiting_var,
            'problem_var': problem_var,
            'hardness_var': hardness_var,
            'row_idx': row_idx,
            'current_status_label': current_status_label,
        }

        waiting_menu.configure(command=lambda selected, rd=row_data: self.on_waiting_type_change(rd, selected))
        problem_menu.configure(command=lambda selected, rd=row_data: self.on_problem_type_change(rd, selected))
        hardness_menu.configure(command=lambda value, rd=row_data: self.on_hardness_change(rd, value))

        self.row_widgets.append(row_data)

        self.configure_option_button_for_row(row_data, problem_var.get())

        if hardness_values == ["Normal"]:
            hardness_menu.set("Normal")
            hardness_menu.configure(state="disabled")

        self.on_problem_type_change(row_data, problem_var.get())

        passage_id유형난이도합본 = row_data['waiting_menu'].get() + ' // ' + row_data['problem_menu'].get() + '_' + row_data['hardness_menu'].get()
        self.update_current_status_label수동실모(row_idx, passage_id유형난이도합본)

        self.count += 1
        self.plus_button.grid_configure(row=self.count+1, columnspan=7)

        self.update_row_indices()



    def update_current_status_label수동실모(self, row_idx=None, passage_id유형난이도합본=None):
        #print("\n\nupdate_current_status_label수동실모 called in ManualMockTest.py")
        #print(self.main_frame_ref.manual_edited_texts)
        #print(f"passage_id유형난이도합본: {passage_id유형난이도합본}\n\n")

        # If no specific row_idx is provided, update all rows
        if row_idx is None:
            for row_data in self.row_widgets:
                
                current_status_label = row_data['current_status_label']
                current_passage_id = row_data['waiting_menu'].get() + ' // ' + row_data['problem_menu'].get() + '_' + row_data['hardness_menu'].get()
                print(f"row_idx: {row_data['row_idx']}")
                print(f"current_passage_id: {current_passage_id}")

                if current_passage_id in self.main_frame_ref.manual_edited_texts:
                    print("수동 텍스트 존재")
                    current_status_label.configure(text="수동", text_color="red")
                else:
                    print("자동")
                    current_status_label.configure(text="자동", text_color="black")
        else:
            # Original code for specific row_idx
            for row_data in self.row_widgets:
                if row_data['row_idx'] == row_idx:
                    current_status_label = row_data['current_status_label']
                    
                    if passage_id유형난이도합본 in self.main_frame_ref.manual_edited_texts:
                        current_status_label.configure(text="수동", text_color="red")
                    else:
                        current_status_label.configure(text="자동", text_color="black")
                    break

        
    def configure_option_button_for_row(self, row_data, problem_type):
        option_button = row_data['option_button']
        if problem_type in self.문제rows_with_options:
            command = self.get_option_command(row_data)
            if command:              
                option_button.configure(state="normal", command=command)
            else:
                option_button.configure(state="disabled", command=lambda: None)
        else:
            option_button.configure(state="disabled", command=lambda: None)
    

    """def configure_option_button_for_row(self, row_data, problem_type):
        option_button = row_data['option_button']
        # Just always enable, or enable/disable if necessary:
        option_button.configure(state="normal", command=self.get_option_command(row_data))
    """



    def update_row_indices(self):
        for i, rd in enumerate(self.row_widgets, start=1):
            rd['row_idx'] = i  # Update the stored row index
            rd['index_label'].configure(text=str(i))  # Update the displayed label


    def delete_row(self, row_data):
        # Destroy widgets of this row
        for key, widget in row_data.items():
            if hasattr(widget, 'destroy') and widget is not None:
                widget.destroy()

        # Remove from row_widgets
        self.row_widgets.remove(row_data)
        self.count -= 1

        # Re-label the rows
        for i, rd in enumerate(self.row_widgets, start=1):
            rd['index_label'].configure(text=str(i))
            rd['index_label'].grid(row=i, column=0)
            rd['waiting_menu'].grid(row=i, column=1)
            rd['problem_menu'].grid(row=i, column=2)
            rd['hardness_menu'].grid(row=i, column=3)
            rd['current_status_label'].grid(row=i, column=4)
            if rd['option_button']:
                rd['option_button'].grid(row=i, column=5)
            rd['delete_button'].grid(row=i, column=6)

        # Move plus button
        self.plus_button.grid_configure(row=len(self.row_widgets)+1, columnspan=7)

        # Update all row indices
        self.update_row_indices()

    def load_waiting_list_items(self):
        if not self.excel_file:
            return []
        try:
            wb = load_workbook(self.excel_file, read_only=True, data_only=True)
            if "대기열" not in wb.sheetnames:
                return []
            sheet = wb["대기열"]
            items = []
            for row in sheet.iter_rows(min_col=1, max_col=1, values_only=True):
                if row[0] is not None and str(row[0]).strip() != "지문을 선택하세요":
                    items.append(str(row[0]).strip())
            return items
        except:
            return []





    def get_option_command(self, row_data):
        """
        Return a function (closure) that fetches the most up-to-date values
        from the row_data dict each time the '옵션' button is clicked.
        """

        def _open_option():
            # Grab the current values from row_data at the time of the click:
            row_idx = row_data['row_idx']
            problem_type = row_data['problem_var'].get()
            waiting_text = row_data['waiting_var'].get()
            hardness = row_data['hardness_var'].get()

            # For your example, you seem to want 실모flag = True:
            실모flag = True
            
            # Now call the correct popup or function depending on the problem_type:
            if problem_type == "내용일치":
                # If 내용일치_option takes the same arguments, do:
                self.내용일치_option()

            elif problem_type == "함축의미":
                self.함축의미_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)

            elif problem_type == "빈칸추론":
                self.빈칸추론_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)

            elif problem_type == "추론":
                self.추론_option()

            elif problem_type == "추론불가":
                self.추론불가_option()

            elif problem_type == "순서":
                self.순서_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)

            elif problem_type == "삽입":
                self.삽입_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)

            elif problem_type == "요지":
                self.요지_option()

            elif problem_type == "요약":
                self.요약_option()

            elif problem_type == "영작1":
                self.영작1_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)

            elif problem_type == "영작2":
                self.영작2_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)

            elif problem_type == "동형문제":
                #self.동형문제_option(실모flag, waiting_text, row_idx, hardness, manual_mocktest_popup=self)
                self.동형문제_option()

            else:
                # No matching type — do nothing or show a warning
                pass

        return _open_option






    """
    def get_option_command(self, row_type, row_data):
        실모flag = True
        
        row_idx = row_data['row_idx']  # Get the row index
        수동출제할지문번호 = row_data['waiting_var'].get()
        유형 = row_data['problem_var'].get()
        난이도 = row_data['hardness_var'].get()

        print(f"row_idx: {row_idx}")
        print(f"수동출제할지문번호: {수동출제할지문번호}")
        print(f"유형: {유형}")
        print(f"난이도: {난이도}")

        if row_type == '내용일치':
            return self.내용일치_option
        elif row_type == '빈칸추론':
            # Return a lambda that, when called, will execute self.빈칸추론_option(실모flag)
            return lambda: self.빈칸추론_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)
        elif row_type == '함축의미':
            # Return a lambda that, when called, will execute self.빈칸추론_option(실모flag)
            return lambda: self.함축의미_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)

        elif row_type == '추론':
            return self.추론_option
        elif row_type == '추론불가':
            return self.추론불가_option
        elif row_type == '순서':
            return lambda:  self.순서_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)
        elif row_type == '삽입':
            return lambda:  self.삽입_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)
        elif row_type == '요지':
            return self.요지_option
        elif row_type == '요약':
            return lambda: self.요약_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)
        elif row_type == '영작1':
            return lambda:  self.영작1_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)
        elif row_type == '영작2':
            return lambda:  self.영작2_option(실모flag, 수동출제할지문번호, row_idx, 난이도, manual_mocktest_popup=self)

        elif row_type == '동형문제':
            return self.동형문제_option
        return None
"""

    def on_waiting_type_change(self, row_data, selected_type):
        print("on_waiting_type_change called (대기열에서 지문 선택에서 지문이 선택됨)")
        # Update the current status label
        row_idx = row_data['row_idx']
        passage_id유형난이도합본 = row_data['waiting_menu'].get() + ' // ' + row_data['problem_menu'].get() + '_' + row_data['hardness_menu'].get()
        self.update_current_status_label수동실모(row_idx, passage_id유형난이도합본)
        

    def on_problem_type_change(self, row_data, selected_type):
        print("on_waiting_type_change called (문제유형 선택에서 유형이 선택됨)")

        hardness_menu = row_data['hardness_menu']
        # Determine the possible values for hardness based on selected_type
        if selected_type in self.실모rows_with_hard_level:
            hardness_menu.configure(values=["Normal", "Hard"])
            # If the current selection isn't in the new values, reset to "Normal"
            if hardness_menu.get() not in ["Normal", "Hard"]:
                hardness_menu.set("Normal")
            hardness_menu.configure(state="normal")
        else:
            hardness_menu.configure(values=["Normal"])
            hardness_menu.set("Normal")
            hardness_menu.configure(state="disabled")

        # Update option button
        self.configure_option_button_for_row(row_data, selected_type)        

        # Update the current status label
        row_idx = row_data['row_idx']
        passage_id유형난이도합본 = row_data['waiting_menu'].get() + ' // ' + row_data['problem_menu'].get() + '_' + row_data['hardness_menu'].get()
        self.update_current_status_label수동실모(row_idx, passage_id유형난이도합본)

    def on_hardness_change(self, row_data, new_value):
        # If you need to re-configure the option button here:
        self.configure_option_button_for_row(row_data, row_data['problem_var'].get())

        # Update the current status label
        row_idx = row_data['row_idx']
        passage_id유형난이도합본 = row_data['waiting_menu'].get() + ' // ' + row_data['problem_menu'].get() + '_' + row_data['hardness_menu'].get()
        self.update_current_status_label수동실모(row_idx, passage_id유형난이도합본)


    def cancel(self, event=None):
        self.destroy()


    def start(self):
        # Collect the user selections
        waiting_selections = [rd['waiting_var'].get() for rd in self.row_widgets]
        problem_selections = [rd['problem_var'].get() for rd in self.row_widgets]
        hardness_values = [rd['hardness_var'].get() for rd in self.row_widgets]

        # Check if waiting_selections is empty
        if not any(waiting_selections):
            messagebox.showwarning("경고", "지문이 없습니다. '+' 버튼을 클릭하여 지문을 1개 이상 추가하세요")
            return

        # Check if any waiting_selection is "지문을 선택하세요"
        invalid_rows = []
        for i, sel in enumerate(waiting_selections, start=1):
            if sel.strip() == "지문을 선택하세요":
                invalid_rows.append(i)

        if invalid_rows:
            rows_str = ", ".join(str(r) for r in invalid_rows)
            messagebox.showwarning("경고", f"{rows_str}번 문제의 지문이 선택되지 않았습니다.")
            return

        """
        # Check for duplicate (지문, 유형) combinations
        for i in range(len(waiting_selections)):
            for j in range(i+1, len(waiting_selections)):
                if waiting_selections[i] == waiting_selections[j] and problem_selections[i] == problem_selections[j]:
                    messagebox.showwarning(
                        "경고",
                        f"{i+1}번과 {j+1}번의 지문과 유형이 동일합니다. 같은 지문을 같은 유형으로 중복 출제할 수 없습니다."
                    )
                    return
        """
        # Check for duplicate (지문, 유형, 난이도) combinations
        for i in range(len(waiting_selections)):
            for j in range(i+1, len(waiting_selections)):
                if (waiting_selections[i] == waiting_selections[j] and
                    problem_selections[i] == problem_selections[j] and
                    hardness_values[i] == hardness_values[j]):
                    messagebox.showwarning(
                        "경고",
                        f"{i+1}번과 {j+1}번의 지문, 유형, 난이도가 동일합니다. "
                        "같은 지문에 같은 유형과 난이도로 중복 출제할 수 없습니다."
                    )
                    return


        combined_types = [f"{ptype}_{hardness}" for ptype, hardness in zip(problem_selections, hardness_values)]
        self.user_selected_waiting = waiting_selections
        self.user_selected_types = combined_types

        if self.process_excel_callback:
            self.process_excel_callback(
                selected_waiting=self.user_selected_waiting,
                selected_types=self.user_selected_types
            )

        self.destroy()


    def load_presets(self):
        if self.presets_file.exists():
            try:
                with open(self.presets_file, 'r', encoding='utf-8') as file:
                    self.presets = json.load(file)
            except json.JSONDecodeError:
                messagebox.showerror("Error", "프리셋 파일을 불러오는 중 오류가 발생했습니다.")
                self.presets = {}
        else:
            self.presets = {}
        self.preset_combobox.configure(values=list(self.presets.keys()))
        if self.presets:
            self.preset_combobox.set("불러올 프리셋 선택")
        else:
            self.preset_combobox.set("")

    def save_presets_to_file(self):
        try:
            with open(self.presets_file, 'w', encoding='utf-8') as file:
                json.dump(self.presets, file, ensure_ascii=False, indent=4)
        except Exception as e:
            messagebox.showerror("Error", f"프리셋을 저장하는 중 오류가 발생했습니다: {e}")

    def save_preset(self):
        preset_name = self.preset_name_entry.get().strip()
        if not preset_name:
            messagebox.showwarning("Warning", "프리셋 이름을 입력해주세요.")
            return
        if preset_name in self.presets:
            overwrite = messagebox.askyesno("Overwrite", f"프리셋 '{preset_name}'을(를) 덮어쓰시겠습니까?")
            if not overwrite:
                return

        # Collect current selections
        problem_selections = [rd['problem_var'].get() for rd in self.row_widgets]
        hardness_values = [rd['hardness_var'].get() for rd in self.row_widgets]

        self.presets[preset_name] = {
            "types": problem_selections,
            "hardness": hardness_values
        }

        self.save_presets_to_file()
        self.preset_combobox.configure(values=list(self.presets.keys()))
        self.preset_combobox.set(preset_name)
        self.preset_name_entry.delete(0, tk.END)
        messagebox.showinfo("Success", f"프리셋 '{preset_name}'이(가) 저장되었습니다.")

    def delete_preset(self):
        preset_name = self.preset_combobox.get()
        if not preset_name:
            messagebox.showwarning("Warning", "삭제할 프리셋을 선택해주세요.")
            return
        confirm = messagebox.askyesno("Confirm Delete", f"프리셋 '{preset_name}'을(를) 삭제하시겠습니까?")
        if confirm:
            del self.presets[preset_name]
            self.save_presets_to_file()
            self.preset_combobox.configure(values=list(self.presets.keys()))
            if self.presets:
                self.preset_combobox.set(list(self.presets.keys())[0])
            else:
                self.preset_combobox.set("")
            messagebox.showinfo("Deleted", f"프리셋 '{preset_name}'이(가) 삭제되었습니다.")

    def on_preset_selected(self, preset_name):
        if preset_name in self.presets:
            preset_data = self.presets[preset_name]

            problem_selections = preset_data.get("types", [])
            hardness_values = preset_data.get("hardness", [])

            max_rows = len(self.row_widgets)
            problem_selections = (problem_selections[:max_rows] +
                                  [""]*(max_rows-len(problem_selections)))
            hardness_values = (hardness_values[:max_rows] +
                               ["Normal"]*(max_rows-len(hardness_values)))

            for i, rd in enumerate(self.row_widgets):
                selected_type = problem_selections[i]
                hardness = hardness_values[i]

                # If the loaded problem type isn't valid in 실모rows, fall back to first type if available
                if selected_type not in self.실모rows and self.실모rows:
                    selected_type = self.실모rows[0]

                rd['problem_var'].set(selected_type)
                self.on_problem_type_change(rd, selected_type)

                hardness_menu = rd['hardness_menu']
                hardness_menu_values = hardness_menu.cget("values")
                if hardness in hardness_menu_values:
                    hardness_menu.set(hardness)
                else:
                    hardness_menu.set("Normal")

    def randomize_problem_types(self):
        if not self.실모rows:
            messagebox.showwarning("Warning", "실모 문제유형 목록이 비어있습니다.")
            return

        for rd in self.row_widgets:
            selected_type = random.choice(self.실모rows)
            rd['problem_var'].set(selected_type)
            self.on_problem_type_change(rd, selected_type)

    def set_all_hard(self):
        for rd in self.row_widgets:
            hardness_menu = rd['hardness_menu']
            values = hardness_menu.cget("values")
            if "Hard" in values:
                hardness_menu.set("Hard")